<?php

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');
include(get_language_filepath('plugin.lang.php', typetags_PATH));
include_once(typetags_PATH.'admin/functions.php');

// +-----------------------------------------------------------------------+
// |                                edit typetags                          |
// +-----------------------------------------------------------------------+

if (isset($_POST['submit']) and !is_adviser())
{
  $query = '
SELECT name, color
  FROM '.typetags_TABLE.'
;';
  $existing_names = array_from_query($query, 'name');

  $current_name_of = array();
  $current_color_of = array();
  
  $query = '
SELECT id, name, color
  FROM '.typetags_TABLE.'
  WHERE id IN ('.$_POST['edit_list'].')
;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    $current_name_of[ $row['id'] ] = $row['name'];
    $current_color_of[ $row['id'] ] = $row['color'];
  }
  
  $updates = array();
  
  // we must not rename typetag with an already existing name
  foreach (explode(',', $_POST['edit_list']) as $typetag_id)
  {
    if (function_exists('mysql_real_escape_string'))
    {
      $typetag_name = mysql_real_escape_string($_POST['typetag_name-'.$typetag_id]);
      $typetag_color = mysql_real_escape_string($_POST['typetag_color-'.$typetag_id]);
    }
    else
    {
      $typetag_name = mysql_escape_string($_POST['typetag_name-'.$typetag_id]);
      $typetag_color = mysql_escape_string($_POST['typetag_color-'.$typetag_id]);
    }

    if ($typetag_name != $current_name_of[$typetag_id])
    {
      if (in_array($typetag_name, $existing_names))
      {
        array_push(
          $page['errors'],
          sprintf(
            l10n('typetags_already exists'),
            $typetag_name
            )
          );
      }
      else if (!empty($typetag_name) and !empty ($typetag_color))
      {
        array_push(
          $updates,
          array(
            'id' => $typetag_id,
            'name' => $typetag_name,
            'color' => $typetag_color,
            )
          );
      }
    }
    
    
  if ($typetag_color != $current_color_of[$typetag_id])
    {
      if (!empty($typetag_name) and !empty ($typetag_color))
      {
        array_push(
          $updates,
          array(
            'id' => $typetag_id,
            'name' => $typetag_name,
            'color' => $typetag_color,
            )
          );
      }
    }
 }
  
  mass_updates(
    typetags_TABLE,
    array(
      'primary' => array('id'),
      'update' => array('name', 'color'),
      ),
    $updates
    );
}

// +-----------------------------------------------------------------------+
// |                               delete typetags                             |
// +-----------------------------------------------------------------------+

if (isset($_POST['deletetypetag']) and isset($_POST['typetags']) and !is_adviser())
{
  $query = '
SELECT name
  FROM '.typetags_TABLE.'
  WHERE id IN ('.implode(',', $_POST['typetags']).')
;';
  $typetag_names = array_from_query($query, 'name');
  
  $query = ' UPDATE '. TAGS_TABLE .'
      SET id_typetags =  NULL
      WHERE id_typetags IN ('.implode(',', $_POST['typetags']).')
         ;';
 pwg_query($query);   

  $query = '
  DELETE
  FROM '.typetags_TABLE.'
  WHERE id IN ('.implode(',', $_POST['typetags']).')
;';
  pwg_query($query);
  
  array_push(
    $page['infos'],
    l10n_dec(
      'typetag_suppr', 
      'typetags_suppr',
      count($typetag_names)).' : '.
      implode(', ', $typetag_names)
    );
}

// +-----------------------------------------------------------------------+
// |                               add a typetag                           |
// +-----------------------------------------------------------------------+

if (isset($_POST['addtypetag']) and !empty($_POST['add_typetag']) and !empty ($_POST['hexval']) and !is_adviser())
{
  $typetag_name = $_POST['add_typetag'];
  $typetag_color = $_POST['hexval'];

  // does the tag already exists?
  $query = '
SELECT id
  FROM '.typetags_TABLE.'
  WHERE name = \''.$typetag_name.'\'
;';
  $existing_tags = array_from_query($query, 'id');

  if (count($existing_tags) == 0)
  {
    mass_inserts(
      typetags_TABLE,
      array('name', 'color'),
      array(
        array(
          'name' => $typetag_name,
          'color' => $typetag_color,
          )
        )
      );
    
    array_push(
      $page['infos'],
      sprintf(
        l10n('typetags_saved'),
        stripslashes($typetag_name)
        )
      );
  }
  else
  {
    array_push(
      $page['errors'],
      sprintf(
        l10n('typetags_already exists'),
        stripslashes($typetag_name)
        )
      );
  }
}

elseif (isset($_POST['add']) and !is_adviser())
{ 
array_push($page['errors'], l10n('typetags_error'));
}

// +-----------------------------------------------------------------------+
// |                            existing tag and typetag list              |
// +-----------------------------------------------------------------------+

$query = '
SELECT id , name
FROM ' . TAGS_TABLE . '
ORDER by id';
$result = pwg_query($query);

$template->assign_block_vars('existing_tag_list',
    array('VALUE' => 0,
        'OPTION' => '&nbsp;'));

while ($row = mysql_fetch_assoc($result)) {

      $template->assign_block_vars('existing_tag_list',
            array('VALUE' => $row['id'],
                  'OPTION' => $row['name']));
}

$query = '
SELECT id , name
FROM ' . typetags_TABLE . '
ORDER by id';
$result = pwg_query($query);

$template->assign_block_vars('existing_typetag_list',
    array('VALUE' => 0,
        'OPTION' => $lang['choose_typetag']));
        

while ($row = mysql_fetch_assoc($result)) {

      $template->assign_block_vars('existing_typetag_list',
            array('VALUE' => $row['id'],
                  'OPTION' => $row['name']));
}


// +-----------------------------------------------------------------------+
// |                           Associate Tag to Typetage                   |
// +-----------------------------------------------------------------------+

$template->assign_vars(
  array(
    'TAG_SELECTION' => get_html_tag_selection(
      get_all_tags(),
      'tags'
      ),
    )
  );

if (isset($_POST['associate']) AND !empty($_POST['tags']) AND ($_POST['typetaglist'] != 0))
{
  $typetag_id = $_POST['typetaglist'];

  $template->assign_block_vars(
    'edit_tags',
    array(
      'LIST' => implode(',', $_POST['tags']),
      )
    );

  $query = '
	  SELECT id, name
	  FROM '.TAGS_TABLE.'
	  WHERE id IN ('.implode(',', $_POST['tags']).');';
	  
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    $name_of[ $row['id'] ] = $row['name'];
  }

  foreach ($_POST['tags'] as $tag_id)
  {
    $template->assign_block_vars(
      'edit_tags.tag',
      array(
        'ID' => $tag_id,
        'NAME' => $name_of[$tag_id],
         )
      );
  }

$query = ' UPDATE '. TAGS_TABLE .'
      SET id_typetags = '. $typetag_id .'
       WHERE id IN ('.implode(',', $_POST['tags']).')
         ;';
 pwg_query($query);   
    
    array_push(
      $page['infos'],
      sprintf(
        l10n('typetags_associated'),
        stripslashes($typetag_id)
        )
      );
}

elseif (isset($_POST['associate']) and !is_adviser())
{ 
array_push($page['errors'], l10n('error_associate'));
}

// +-----------------------------------------------------------------------+
// |                           Dissociate Tag to Typetage                  |
// +-----------------------------------------------------------------------+

if (isset($_POST['dissociate']) AND !empty($_POST['dissoc_tags']) and !is_adviser())
{
  $associated_tag_id = implode(',', $_POST['dissoc_tags']);

 $query = ' UPDATE '. TAGS_TABLE .'
          SET id_typetags = NULL
          WHERE id IN (' . $associated_tag_id . ')
          ;';
   pwg_query($query);

 
    array_push($page['infos'],
      sprintf(l10n('typetags_dissociated'),
        stripslashes($associated_tag_id )
        )
      );
}


elseif (isset($_POST['dissociate']) and !is_adviser())
{ 
array_push($page['errors'], l10n('error_dissociate'));
}

//Recupere les tags associs

		$query = '
		  SELECT id , name
		  FROM ' . TAGS_TABLE . '
		  WHERE id_typetags is NOT NULL
		  ORDER by id';
		$result = pwg_query($query);

$tags = array();
	while ($row = mysql_fetch_assoc($result))
          {
     array_push($tags, $row);

		}
usort($tags, 'name_compare');

$template->assign_vars(array('TAG_TO_DISSOC_SELECTION' => get_html_tag_selection($tags,'dissoc_tags')));

// +-----------------------------------------------------------------------+
// |                             template init                             |
// +-----------------------------------------------------------------------+

$template->set_filenames(array('plugin_admin_content' => typetags_PATH . 'admin/typetags_admin.tpl'));

// +-----------------------------------------------------------------------+
// |                             form creation                             |
// +-----------------------------------------------------------------------+

$template->assign_vars(
  array(
    'TYPETAG_SELECTION' => get_html_typetag_selection(
      get_all_typetags(),
      'typetags'
      ),
    )
  );

if (isset($_POST['edittypetag']) and isset($_POST['typetags']))
{
  $template->assign_block_vars(
    'edit_typetags',
    array(
      'LIST' => implode(',', $_POST['typetags']),
      )
    );

  $query = '
SELECT id, name, color
  FROM '.typetags_TABLE.'
  WHERE id IN ('.implode(',', $_POST['typetags']).')
;';
  $result = pwg_query($query);
  while ($row = mysql_fetch_array($result))
  {
    $name_of[ $row['id'] ] = $row['name'];
    $color_of[ $row['id'] ] = $row['color'];
  }

  foreach ($_POST['typetags'] as $typetag_id)
  {
    $template->assign_block_vars(
      'edit_typetags.typetag',
      array(
        'ID' => $typetag_id,
        'NAME' => $name_of[$typetag_id],
        'COLOR'=> $color_of[$typetag_id],
         )
      );
  }
}

// +-----------------------------------------------------------------------+
// |                           sending html code                           |
// +-----------------------------------------------------------------------+

$template->assign_var_from_handle('ADMIN_CONTENT', 'plugin_admin_content');

?>